/*
   This tokenizer is for the JSON example.
*/

public class JSONTokenizer
{
   private java.util.StringTokenizer tokenizer;
   private boolean hasPeeked = false;
   private String peekedAtToken = "";

   public JSONTokenizer(String string)
   {
      tokenizer = new java.util.StringTokenizer(string.trim(), "[]{}\":,", true);
   }


   public String nextToken()
   {
      if (hasPeeked)
      {
         hasPeeked = false;
         return peekedAtToken;
      }
      else
      {  // make sure to get rid of any whitespace
         String tk = tokenizer.nextToken().trim();
         if ( tk.equals("") )
         {
            return tokenizer.nextToken().trim();
         }
         else
         {
            return tk;
         }
      }
   }


   public boolean match(String tk)
   {
      return tk.equals( this.nextToken() );
   }


   public String peekToken()
   {
      if (hasPeeked)
      {
         return peekedAtToken;
      }
      else
      {
         peekedAtToken = this.nextToken();
         hasPeeked = true;
         return peekedAtToken;
      }
   }


   public boolean hasToken()
   {
      return hasPeeked || tokenizer.hasMoreTokens();
   }


   public int countTokens()
   { // NOT accurate, since the tokenizer counts whitespace tokens
      return tokenizer.countTokens();
   }

}//JSONTokenizer
