/*
   This program creates parse trees from JSON expressions.
*/

public class TestJSON2ParseTree
{
   public static void main(String[] args) throws Exception
   {
      String[] json =
      {
         "{}",

         "{ a1:[], a2:[] }",

         "{o1:{}, a1:[], s1:3}",

         "{o1:{x:1, y:2, z:3}, a1:[123,[{x:1}, {y:2}, {z:3}]], s1:\"pears\"}"
      };

      for (int i = 0; i < json.length; i++)
      {
         System.out.println( json[i] );
         Tree parseTree = JSON2ParseTree.parseJSON( json[i] );
         System.out.println( parseTree+"\n" );

         // Create dot and png files from the two trees.
         try
         {
            // Create the dot file.
            java.io.PrintWriter out = new java.io.PrintWriter(
                                      new java.io.File("JSON-"+(i+1)+"-ParseTree.dot") );
            // Put dot commands into the dot file.
            out.println(  Tree2dot.tree2dot(parseTree) + "\n" );
            out.close();

            // Create a Windows command lines for running dot.exe.
            String[] cmd = {"dot.exe",
                            "-Tpng",
                            "JSON-"+(i+1)+"-ParseTree.dot",
                            "-o",
                            "JSON-"+(i+1)+"-ParseTree.png"};
            // Execute the command line.
            java.lang.Runtime.getRuntime().exec(cmd);
         }
         catch (Exception e)
         {
            System.out.println( e );
         }
      }
   }//main()
}//TestJSON2ParseTree